//  http://java.sun.com/j2se/1.5.0/docs/api/java/util/Scanner.html
import java.io.*;
import java.util.*;
import java.lang.*;

public class weps8 
{
  static int np =2003;
  static int nr = np*np;
  static double a1=1.0;
  static double a2=3.0;
  static double a3=3.0;
  static double teps=0.1;
  static double tmin=-1.0;
  static random1 r1 = new random1();
  static random2 r2 = new random2();
  public static void main(String args[])
  {
    double tcp=0,an;

    double a[][] = new double[np][np];
    double b[][] = new double[np][np];
    double x[] = new double[np];
    double y[] = new double[np];
    double v[] = new double[np];
    double aa[] = new double[nr];
    int indx[] = new int[np];
    int n;
    double dummy = r1.ran1(-1);
    dummy = r2.ran2(-1);
    Scanner sc = new Scanner(System.in);
    n = np;
    System.out.println("THIS IS PROGRAM WEPS: MEASURES CPU SPEED");
    System.out.println("JAVA VERSION");
    while (true)
    {
      System.out.println("ENTER ORDER OF MATRICES TO BE USED, 0 TO STOP");
      n = sc.nextInt();
      an = n;
      if ( n == 0)
        break;
      if (n > np || n <= 1 ) 
      {
        System.out.println("ORDER MUST BE IN THE RANGE 2.."+np);
        continue;
      }
      if (tmin <= 0)
      {
        tmin = dettmi();
        tmin = dettmi();
        tcp = meatcp(tmin);
        tcp = meatcp(tmin);
        tmin=Math.max(Math.max(100.0*tcp,tmin),1.0);
        System.out.println("MINIMUM CPU TIME PER MEASUREMENT IS "+tmin+" SEC");
      }
      int nsort = n*n;

      System.out.println("NUMBER CRUNCHING ...");
      double t1 = tstran(a,n,np,tcp,tmin);
             t1 = tstran(a,n,np,tcp,tmin);
      double t2 = tstsol(a,b,x,y,v,indx,n,np,tcp,tmin);
             t2 = tstsol(a,b,x,y,v,indx,n,np,tcp,tmin);
      double t3 = tstsor(aa,nsort,tcp,tmin);
             t3 = tstsor(aa,nsort,tcp,tmin);

      char mark1=' ';
      char mark2=' ';
      char mark3=' ';
      char markh=' ';

      if (tcp > teps*t1) mark1='*';
      if (tcp > teps*t2) mark2='*';
      if (tcp > teps*t3) mark3='*';

      boolean inac = mark1 != ' ' || mark2 != ' ' || mark3 != ' ';
      if (inac)
        markh = '*';

      double c1 = 10*an*an;
      double c2 = 1.0/3*(an*an*an+11*an*an);
      double c3 = nsort*Math.log((double)nsort);

      double w1 = c1/t1*0.001;
      double w2 = c2/t2*0.001;
      double w3 = c3/t3*0.001;

      System.out.println("DECLARED ORDER OF MATRICES: "+np);
      System.out.println("ORDER OF MATRICES:          "+n);
      System.out.println("DIMENSION OF SORT ARRAY:    "+nsort);

      double hw = (a1+a2+a3)/(a1/w1+a2/w2+a3/w3);


      System.out.print("                                   ");
      System.out.print("WEIGHT    CPUTIME");
      System.out.println("         SPEED");
      System.out.print("                                             ");
      System.out.print("(SECONDS)");
      System.out.println("      (KILOWEPS)");
      System.out.println("");


      String form = "%9d:%7.1f%12.6f%14.1f    %c%n";
      String formh = "         :                   %14.1f    %c%n";
      System.out.format("SUBROUTINE, # CALLS IS "+form,n*n,a1,t1,w1,mark1);
      System.out.format("LIN EQUATIONS OF ORDER "+form,n,a2,t2,w2,mark2);
      System.out.format("SORTING, # ELEMENTS IS "+form,n*n,a3,t3,w3,mark3);
      System.out.format("HARMONIC WEIGHTED MEAN "+formh,hw,mark3);

      if (inac)
        System.out.println(" * MEANS: POSSIBLY INACCURATE");
        System.out.println("");
        System.out.println(" END OF THIS WEPS MEASUREMENT");
    }
  System.out.println(" END OF PROGRAM WEPS");

  }
  public static double tstran(double a[][],int n, int np, 
                double tcp, double tmin)
  {
    int loop = 0;
    double t0 = cptime();
    double dt = 0;
    double t;
    while (dt < tmin)
    {
      loop++;
      for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
          a[i][j] = r1.ran1(1);

      t = cptime();
      dt = t -t0-loop*tcp;
    }

    t = dt/loop;
    return t;
  }
  public static class random1
  {
    private double r[] = new double[98];
    private final int m1=259200,ia1=7141,ic1=54773;
    private final double rm1=1.0/m1;
    private final int m2=134456,ia2=8121,ic2=28411;
    private final double rm2=1.0/m2;
    private final int m3=243000,ia3=4561,ic3=51349;

    private int iff=0;
    private int ix1,ix2,ix3;

    public double ran1(int idum)
    {
      if (idum < 0 || iff == 0)
      {
        iff = 1;
        ix1=Math.abs((ic1-idum)%m1);
        ix1=(ia1*ix1+ic1) % m1;
        ix2 = ix1 % m2;
        ix1 = (ia1*ix1+ic1) % m1;
        ix3 = ix1 % m3;

        for (int j=1; j<=97; j++)
        {
          ix1 = (ia1*ix1+ic1) % m1;
          ix2 = (ia2*ix2+ic2) % m2;
          r[j] = ((double)ix1 + rm2*(double)ix2)*rm1;
        }
      }

      ix1 = (ia1*ix1+ic1) % m1;
      ix2 = (ia2*ix2+ic2) % m2;
      ix3 = (ia3*ix3+ic3) % m3;

      int j = 1+(97*ix3)/m3;
      if (j > 97 || j < 1)
      {
        System.out.println("THIS SHOULD NOT HAPPEN !!!, ROUTINE RAN1");
        System.out.println("J="+j);
        System.exit(1);
      }
      double x = r[j];
      r[j] = ((double)ix1+rm2*(double)ix2)*rm1;
      return x;
    }
  }

  public static class random2
  {
    private int iy,jdum;
    private int iff=0;
    private final int m=714025, ia=1366, ic=150889;
    private final double rm=1.0/m;

    private int ir[] = new int[98];

    public double ran2(int idum)
    {
      if (idum < 0 || iff == 0)
      {
        iff = 1;
        jdum = Math.abs((ic-idum) % m);
        for (int j=1; j<=97; j++)
        {
          jdum = (ia*jdum+ic) % m;
          ir[j] = jdum;
        }
        jdum = (ia*jdum+ic) % m;
        iy = jdum;
      }
      int j = 1+(97*iy)/m;
      if (j > 97 || j < 1)
      {
        System.out.println("THIS SHOULD NOT HAPPEN !!!, FUNCTION RAN2");
        System.out.println("J="+j);
        System.exit(1);
      }
      iy = ir[j];
      double x = iy*rm;
      jdum = (ia*jdum+ic) % m;
      ir[j] = jdum;
      return x;
    }


  }
  public static double tstsol(double a[][], double b[][], double x[],
      double y[], double v[], int indx[], 
      int n, int np, double tcp, double tmin)
  {
    for (int i=0; i<n; i++)
    {
      for (int j=0; j<n; j++)
        b[i][j] = r2.ran2(1);
      y[i] = r2.ran2(1);
    }

    int loop = 0;
    double dt = 0;
    double t0 = cptime();
    while (dt < tmin)
    {
      loop++;
      for (int i=0; i<n; i++)
      {
        for (int j=0; j<n; j++)
          a[i][j] = b[i][j];
        x[i] = y[i];
      }
      double d[] = new double[1];
      int ier = ludcmp(a,n,np,indx,d,v);
      if (ier != 0)
      {
        System.out.println("MATRIX SINGULAR IN TSTSOL");
        System.out.println("PROGAM ENDS HERE");
        System.exit(1);
      }
      lubksb(a,n,np,indx,x);
      for (int i=0; i<n; i++)
      {
        double s=0;
        for (int j=0; j<n; j++)
          s += b[i][j]*x[j];
        if (Math.abs(s-y[i]) > 0.01*n)
        {
          System.out.println("INCORRECT SOLUTION IN TSTSOL");
          System.out.println("PROGAM ENDS HERE");
          System.exit(1);
        }
      }

      double t = cptime();
      dt = t - t0 - loop*tcp;
    }
    return dt/loop;
  }

  public static int ludcmp(double a[][], int n, int np, int indx[],
                           double d[], double vv[])
  {
    final double tiny = 1.0e-20;
    d[0] = 1;

    int ier = 0;
    int imax = -1;
    double aamax;

    for (int i=0; i<n; i++)
    {
      aamax = 0.0;
      for (int j =0; j<n; j++)
        if (Math.abs(a[i][j]) > aamax)
          aamax = Math.abs(a[i][j]);
      if (aamax == 0.0)
      {
        ier = 1;
        d[0] = 0;
        return ier;
      }
      vv[i] = 1.0/aamax;
    }
    for (int j=0; j<n; j++)
    {
      if (j > 0)
      {
        for (int i=0; i<j; i++)
        {
          double sum = a[i][j];
          if (i > 0) 
          {
            for (int k=0; k<i; k++)
              sum -= a[i][k]*a[k][j];
            a[i][j] = sum;
          }
        }
      }
      aamax = 0;
      for (int i=j; i<n; i++)
      {
        double sum = a[i][j];
        if ( j > 0)
        {
          for (int k=0; k<j; k++)
            sum -= a[i][k]*a[k][j];
          a[i][j] = sum;
        }
        double dum = vv[i]*Math.abs(sum);
        if (dum > aamax)
        {
          imax = i;
          aamax = dum;
        }
      }
      if (j != imax)
      {
        for (int k=0; k<n; k++)
        {
          double dum = a[imax][k];
          a[imax][k] = a[j][k];
          a[j][k] = dum;
        }
        d[0] = -d[0];
        vv[imax] = vv[j];
      }
      indx[j] = imax;
      if ( j != n-1 )
      {
        if (a[j][j] == 0)
        {
          a[j][j] = tiny;
          ier = 2;
        }
        double dum = 1.0/a[j][j];
        for (int i=j+1; i<n; i++)
          a[i][j] = a[i][j]*dum;
      }
    }
    if (a[n-1][n-1] == 0)
      a[n-1][n-1] = tiny;
    return ier;
  }

  public static void lubksb(double a[][], int n, int np, int indx[], 
                           double b[])
  {
    int ii=-1;
    for (int i=0; i<n; i++)
    {
      int ll = indx[i];
      double sum = b[ll];
      b[ll] = b[i];
      if (ii != -1)
      {
        for (int j=ii; j<i; j++)
          sum -= a[i][j]*b[j];
      }
      else
      {
        if (sum != 0.0)
          ii = i;
      }
      b[i] = sum;
    }
    for (int i=n-1; i>=0; i--)
    {
      double sum = b[i];
      if ( i < n-1)
      {
        for (int j=i+1; j<n; j++)
          sum -= a[i][j]*b[j];
      }
      b[i] = sum/a[i][i];
    }
    return;
  }

  public static double tstsor(double a[], int n, double tcp, double tmin)
  {
    for (int i=0; i<n; i++)
      a[i] = r2.ran2(1);

    sort(a,n);

    double t;
    int loop = 0;
    double t0 = cptime();

    double dt = 0;

    while (dt < tmin)
    {
      loop++;
      sort(a,n);

      t = cptime();
      dt=t - t0 -loop*tcp;
    }
    t = dt/loop;

    boolean lll=true;

    for (int i=0; i<n-1; i++)
      lll = lll && (a[i] <= a[i+1]);

    if (!lll)
    {
      System.out.println("ARRAY NOT SORTED IN TSTSOR");
      System.out.println("PROGRAM ENDS HERE");
      System.exit(1);
    }

    return t;
  }

  public static void sort(double ra[], int n)
  {
    int l=n/2;
    int ir = n-1;
    double rra;

    while (true)
    {
      if ( l > 0 )
      {
        l--;
        rra=ra[l];
      }
      else
      {
        rra = ra[ir];
        ra[ir] = ra[0];
        ir--;
        if(ir == 0)
        {
          ra[0] = rra;
          return;
        }
      }
      int i = l;
      int j = l+l+1;
      while(j <= ir)
      {
        if (j < ir)
          if (ra[j] < ra[j+1])
            j++;
        if(rra < ra[j])
        {
          ra[i] = ra[j];
          i = j;
          j = j+j+1;
        }
        else
          j = ir+1;
      }
      ra[i] = rra;
    }
  }

  public static double dettmi()
  {
    double t0 = cptime();

    int m = 10;
    double p = 100.0;
    double dt = 0;

    double t = t0;
    for (int i=0; i<m; i++)
    {
      while (t == t0)
        t = cptime();
      dt += t - t0;
      t0 = t;
    }

    double tmin = p*dt/m;

    if(tmin > 100.0) 
    {
      System.out.println("MINIMUM TIME FOR MEASUREMENTS GREATER THAN 100 SEC");
      System.out.println("SOMETHING IS PROBABLY WRONG, PROGRAM STOPS");
      System.exit(1);
    }
    return tmin;
  }
  public static double cptime()
  {
    return System.currentTimeMillis()*0.001;
  }
  public static double meatcp(double tmin)
  {
    int loop = 0;
    double t0 = cptime();
    double tcp = loop*t0;

    double dt = 0;
    while (dt < tmin)
    {
      loop++;
      double t = cptime();
      dt = t - t0 - loop*tcp;
    }
    tcp = tmin/loop;
    return tcp;
  }

}
